Index: src/toolbar.c
===================================================================
--- src/toolbar.c	(revision 4308)
+++ src/toolbar.c	(working copy)
@@ -26,6 +26,7 @@
 #include "support.h"
 
 struct toolbar_window toolbar_wnd = { 0 };
+struct menubar_window menubar_wnd = { 0 };
 
 /* Put some buttons of the toolbar as sensitive according to some options */
 void toolbar_refresh_buttons(void)
@@ -42,9 +44,16 @@
 	gtk_widget_set_sensitive(toolbar_wnd.button12, features & OPS_BACKUP);
 	gtk_widget_set_sensitive(toolbar_wnd.button13, features & OPS_BACKUP);
 	gtk_widget_set_sensitive(toolbar_wnd.button14, !(features & FTS_SILENT) || !options.full_gui);
+	gtk_widget_show(toolbar_wnd.button15);
 
-	if(options.full_gui)
-		gtk_widget_hide(toolbar_wnd.button15);
-	else
-		gtk_widget_show(toolbar_wnd.button15);
+	gtk_widget_set_sensitive(menubar_wnd.backup, features & OPS_BACKUP);
+	gtk_widget_set_sensitive(menubar_wnd.restore, features & OPS_BACKUP);
+	gtk_widget_set_sensitive(menubar_wnd.setclock, features & OPS_CLOCK);
+	gtk_widget_set_sensitive(menubar_wnd.idlist, features & OPS_IDLIST);
+	gtk_widget_set_sensitive(menubar_wnd.dumprom, features & OPS_ROMDUMP);
+	gtk_widget_set_sensitive(menubar_wnd.restore, features & OPS_BACKUP);
+
+	gtk_check_menu_item_set_active(menubar_wnd.viewlocal, options.full_gui);
+	gtk_check_menu_item_set_active(menubar_wnd.showall, options.show_all);
+
 }
Index: src/tilp.c
===================================================================
--- src/tilp.c	(revision 4308)
+++ src/tilp.c	(working copy)
@@ -45,6 +45,7 @@
 #include "filesel.h"
 #include "action.h"
 #include "gtk_update.h"
+#include "screenshot.h"
 
 #ifdef __WIN32__
 #define strcasecmp _stricmp
@@ -56,6 +58,7 @@
 GtkWidget *ctree_wnd = NULL;
 GtkWidget *help_menu = NULL;
 
+
 /* Main window */
 
 void show_right_view(int view)
@@ -113,12 +116,21 @@
 	toolbar_wnd.button21 = glade_xml_get_widget(xml, "button11");
 	toolbar_wnd.button22 = glade_xml_get_widget(xml, "button12");
 
+	menubar_wnd.menubar = glade_xml_get_widget(xml, "menubar1");
+	menubar_wnd.viewlocal = glade_xml_get_widget(xml, "menuitem13");
+	menubar_wnd.showall = glade_xml_get_widget(xml, "show_all_files1");
+	menubar_wnd.restore = glade_xml_get_widget(xml, "imagemenuitem4");
+	menubar_wnd.backup = glade_xml_get_widget(xml, "imagemenuitem3");
+	menubar_wnd.idlist = glade_xml_get_widget(xml, "menuitem10");
+	menubar_wnd.setclock = glade_xml_get_widget(xml, "menuitem9");
+	menubar_wnd.dumprom = glade_xml_get_widget(xml, "menuitem8");
+
 	paned = glade_xml_get_widget(xml, "hpaned1");
 	gtk_paned_set_position(GTK_PANED(paned), options.pane_x_size);
 
 	show_right_view(options.full_gui);
 	help_menu = glade_xml_get_widget(xml, "help_menu1");
-	
+
 	clist_init();
 	ctree_init();
 	dnd_init();
@@ -668,13 +680,20 @@
 				       0, gtk_get_current_event_time ());
 }
 
+// take screenshot
+GLADE_CB void on_tilp_menuitem7_clicked(GtkButton* button, gpointer user_data)
+{
+	display_screenshot_dbox();
+
+}
+
 // change folder
 GLADE_CB void
 on_button14_clicked                    (GtkButton       *button,
                                         gpointer         user_data)
 {
 	gchar *folder;
-	
+
 	folder = msg_entry(_("Path"), _("Enter new path"), local.cwdir);
 	if(folder != NULL)
 	{
@@ -690,3 +709,34 @@
 		g_free(folder);
 	}
 }
+
+// set clock
+GLADE_CB void on_tilp_menuitem9_clicked(GtkButton* button, gpointer user_data)
+{
+	display_clock_dbox();
+
+}
+
+//get id-list
+GLADE_CB void on_tilp_menuitem10_clicked(GtkButton* button, gpointer user_data)
+{
+	tilp_calc_idlist(0);
+
+}
+
+//get calc info
+GLADE_CB void on_tilp_menuitem12_clicked(GtkButton* button, gpointer user_data)
+{
+	CalcInfos infos;
+	tilp_calc_get_infos(&infos);
+
+}
+
+
+//update View menu
+GLADE_CB void on_tilp_viewmenu_active(GtkButton* button, gpointer user_data)
+{
+
+
+}
+
Index: src/gstruct.h
===================================================================
--- src/gstruct.h	(revision 4308)
+++ src/gstruct.h	(working copy)
@@ -47,8 +47,23 @@
 	GtkWidget* button22;
 } toolbar_wnd;
 
+/* This struct is used by the menubar */
+extern struct menubar_window
+{
+	GtkWidget* menubar;
+	GtkWidget* viewlocal;
+	GtkWidget* showall;
+	GtkWidget* senditem;
+	GtkWidget* backup;
+	GtkWidget* restore;
+	GtkWidget* setclock;
+	GtkWidget* idlist;
+	GtkWidget* dumprom;
+
+} menubar_wnd;
+
 /* This struct is used by the CLabel window */
 extern struct label_window 
 {
 	GtkWidget* label11;
 	GtkWidget* label12;